import base64
import random

def gen_base_keys(min, max):
    a = random.randint(0, min)
    b = random.randint(min, max)

    a *= min
    b *= (max // 2)
    return a, b

def gen_priv_key(a, b):
    c = (a | b) ** 2
    return c

def dynamic_xor_encrypt(plaintext, text_key):
    cipher_text = bytearray()
    key_length = len(text_key)
    for i, char in enumerate(plaintext[::-1]):
        key_char = text_key[i % key_length]
        encrypted_char = chr(ord(char) ^ ord(key_char))
        cipher_text.append(ord(encrypted_char))
    return bytes(cipher_text)

def encode(flag):
    a, b = gen_base_keys(3, 7)
    c = gen_priv_key(a, b)

    print(a, b, c)
    encrypted_flag = dynamic_xor_encrypt(flag, str(c))
    encoded_flag = base64.b64encode(encrypted_flag).decode('utf-8')
    
    return encoded_flag

